<template>
    <i-form :model="this.data" class='app-form' ref='form'  id='empo_main5' style="">
    <input style="display:none;" />
    <row >
            
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group :manageContainerStatus="detailsModel.grouppanel2.manageContainerStatus"  :isManageContainer="detailsModel.grouppanel2.isManageContainer" @managecontainerclick="manageContainerClick('grouppanel2')" layoutType="TABLE_24COL" titleStyle="" class='' :uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.empo.main5_form.details.grouppanel2')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="1" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.empoid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='empoid' :itemRules="this.rules.empoid" class='' :caption="$t('entities.empo.main5_form.details.empoid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.empoid.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.empoid"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.empoid.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rempname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rempname' :itemRules="this.rules.rempname" class='' :caption="$t('entities.empo.main5_form.details.rempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rempname.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-group-select
  name="rempname"
  :value='data.rempname'
  valueitem="rempid"
  url="/ibzorganizations/${selected-orgid}/ibzemployees/picker"
  treeurl="/ibzorganizations/${orgid}/suborg/picker"
  :multiple="false"
  filter="srforgid"
  :fillmap="{'id':'rempid','label':'rempname'}"
  :disabled="detailsModel.rempname.disabled"
  :data="data"
  :context="context"
  @formitemvaluechange="onFormItemValueChange">
</app-group-select>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.pdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='pdate' :itemRules="this.rules.pdate" class='' :caption="$t('entities.empo.main5_form.details.pdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.pdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="datetime" :transfer="true" format="yyyy-MM-dd HH:mm:ss" placeholder="请选择时间..." :value="data.pdate" :disabled="detailsModel.pdate.disabled" style="min-width: 150px; width:160px;" @on-change="(val1, val2) => { this.data.pdate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.eadate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eadate' :itemRules="this.rules.eadate" class='' :caption="$t('entities.empo.main5_form.details.eadate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eadate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="datetime" :transfer="true" format="yyyy-MM-dd HH:mm:ss" placeholder="请选择时间..." :value="data.eadate" :disabled="detailsModel.eadate.disabled" style="min-width: 150px; width:160px;" @on-change="(val1, val2) => { this.data.eadate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.labservicename.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='labservicename' :itemRules="this.rules.labservicename" class='' :caption="$t('entities.empo.main5_form.details.labservicename')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.labservicename.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :localContext ='{ }' 
  :localParam ='{ }' 
  :disabled="detailsModel.labservicename.disabled"
  name='labservicename'
  deMajorField='emservicename'
  deKeyField='emservice'
  :service="service"
  :acParams="{ serviceName: 'EMServiceService', interfaceName: 'FetchDefault'}"
  valueitem='labserviceid' 
  :value="data.labservicename" 
  editortype="" 
  :pickupView="{ viewname: 'emservicepickup-view', title: $t('entities.emservice.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'emservices', parameterName: 'emservice' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.labservicedesc.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='labservicedesc' :itemRules="this.rules.labservicedesc" class='' :caption="$t('entities.empo.main5_form.details.labservicedesc')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.labservicedesc.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.labservicedesc"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.labservicedesc.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.civo.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='civo' :itemRules="this.rules.civo" class='' :caption="$t('entities.empo.main5_form.details.civo')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.civo.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.civo"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.civo.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.payway.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='payway' :itemRules="this.rules.payway" class='' :caption="$t('entities.empo.main5_form.details.payway')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.payway.error" :isEmptyCaption="false" labelPos="LEFT">
    
 <dropdown-list 
    v-model="data.payway" 
    :data="data" 
    :context="context"
    :viewparams="viewparams"
    :localContext ='{ }' 
    :localParam ='{ }' 
    :disabled="detailsModel.payway.disabled"  
    tag='EMPAYWAY' 
    codelistType='STATIC'
    placeholder='请选择...' style="">
 </dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.taxivo.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='taxivo' :itemRules="this.rules.taxivo" class='' :caption="$t('entities.empo.main5_form.details.taxivo')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.taxivo.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.taxivo"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.taxivo.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.taxfee.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='taxfee' :itemRules="this.rules.taxfee" class='' :caption="$t('entities.empo.main5_form.details.taxfee')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.taxfee.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.taxfee"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.taxfee.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.tsivo.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='tsivo' :itemRules="this.rules.tsivo" class='' :caption="$t('entities.empo.main5_form.details.tsivo')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.tsivo.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.tsivo"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.tsivo.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.tsfee.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='tsfee' :itemRules="this.rules.tsfee" class='' :caption="$t('entities.empo.main5_form.details.tsfee')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.tsfee.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.tsfee"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.tsfee.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.poamount.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='poamount' :itemRules="this.rules.poamount" class='' :caption="$t('entities.empo.main5_form.details.poamount')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.poamount.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.poamount"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.poamount.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.postate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='postate' :itemRules="this.rules.postate" class='' :caption="$t('entities.empo.main5_form.details.postate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.postate.error" :isEmptyCaption="false" labelPos="LEFT">
    
 <dropdown-list 
    v-model="data.postate" 
    :data="data" 
    :context="context"
    :viewparams="viewparams"
    :localContext ='{ }' 
    :localParam ='{ }' 
    :disabled="detailsModel.postate.disabled"  
    tag='EMPOSTATE' 
    codelistType='STATIC'
    placeholder='请选择...' style="">
 </dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wfstep.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wfstep' :itemRules="this.rules.wfstep" class='' :caption="$t('entities.empo.main5_form.details.wfstep')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wfstep.error" :isEmptyCaption="false" labelPos="LEFT">
    
 <dropdown-list 
    v-model="data.wfstep" 
    :data="data" 
    :context="context"
    :viewparams="viewparams"
    :localContext ='{ }' 
    :localParam ='{ }' 
    :disabled="detailsModel.wfstep.disabled"  
    tag='EMPOWFSTEP' 
    codelistType='STATIC'
    placeholder='请选择...' style="">
 </dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.apprempname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='apprempname' :itemRules="this.rules.apprempname" class='' :caption="$t('entities.empo.main5_form.details.apprempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.apprempname.error" :isEmptyCaption="false" labelPos="LEFT">
    
<app-group-select
  name="apprempname"
  :value='data.apprempname'
  valueitem="apprempid"
  url="/ibzorganizations/${selected-orgid}/ibzemployees/picker"
  treeurl="/ibzorganizations/${orgid}/suborg/picker"
  :multiple="false"
  filter="srforgid"
  :fillmap="{'id':'apprempid','label':'apprempname'}"
  :disabled="detailsModel.apprempname.disabled"
  :data="data"
  :context="context"
  @formitemvaluechange="onFormItemValueChange">
</app-group-select>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.apprdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='apprdate' :itemRules="this.rules.apprdate" class='' :caption="$t('entities.empo.main5_form.details.apprdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.apprdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="datetime" :transfer="true" format="yyyy-MM-dd HH:mm:ss" placeholder="请选择时间..." :value="data.apprdate" :disabled="detailsModel.apprdate.disabled" style="min-width: 150px; width:160px;" @on-change="(val1, val2) => { this.data.apprdate = val1 }"></date-picker>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel1.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group :manageContainerStatus="detailsModel.grouppanel1.manageContainerStatus"  :isManageContainer="detailsModel.grouppanel1.isManageContainer" @managecontainerclick="manageContainerClick('grouppanel1')" layoutType="TABLE_24COL" titleStyle="" class='' :uiActionGroup="detailsModel.grouppanel1.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.empo.main5_form.details.grouppanel1')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="2" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.orgid.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='orgid' :itemRules="this.rules.orgid" class='' :caption="$t('entities.empo.main5_form.details.orgid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.orgid.error" :isEmptyCaption="false" labelPos="LEFT">
    
 <dropdown-list 
    v-model="data.orgid" 
    :data="data" 
    :context="context"
    :viewparams="viewparams"
    :localContext ='{ }' 
    :localParam ='{ }' 
    :disabled="detailsModel.orgid.disabled"  
    tag='PFCL_ORG' 
    codelistType='STATIC'
    placeholder='请选择...' style="">
 </dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.description.visible" :style="{}"  :md="{ span: 24, offset: 0 }" :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='description' :itemRules="this.rules.description" class='' :caption="$t('entities.empo.main5_form.details.description')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.description.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.description"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.description.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.content.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='content' :itemRules="this.rules.content" class='' :caption="$t('entities.empo.main5_form.details.content')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.content.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.content" :textareaId="this.$util.createUUID()"  :disabled="detailsModel.content.disabled" type='textarea' textareaStyle="height:200px;" ></input-box>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.att.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-item name='att' :itemRules="this.rules.att" class='' :caption="$t('entities.empo.main5_form.details.att')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.att.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-file-upload :formState="formState" :ignorefieldvaluechange="ignorefieldvaluechange" @formitemvaluechange="onFormItemValueChange" :data="JSON.stringify(this.data)" name='att' :value="data.att" :disabled="detailsModel.att.disabled" :uploadparams='{}' :exportparams='{}'  style="overflow: auto;"></app-file-upload>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import EMPOService from '@/service/empo/empo-service';
import Main5Service from './main5-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main5Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main5Base
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main5Base
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main5Base
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main5Base
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main5Base
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main5Base
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main5Service}
     * @memberof Main5Base
     */
    public service: Main5Service = new Main5Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMPOService}
     * @memberof Main5Base
     */
    public appEntityService: EMPOService = new EMPOService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main5Base
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main5Base
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

    /**
     * 工作流审批意见控件绑定值
     *
     * @memberof Main5Base
     */
    public srfwfmemo:string = "";
    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main5Base
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main5Base
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main5Base
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main5Base
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main5Base
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main5Base
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main5Base
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main5Base
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main5Base
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main5Base
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main5Base
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        empoid: null,
        rempid: null,
        rempname: null,
        pdate: null,
        eadate: null,
        labservicename: null,
        labservicedesc: null,
        civo: null,
        payway: null,
        taxivo: null,
        taxfee: null,
        tsivo: null,
        tsfee: null,
        poamount: null,
        postate: null,
        wfstep: null,
        apprempid: null,
        apprempname: null,
        apprdate: null,
        orgid: null,
        description: null,
        content: null,
        att: null,
        labserviceid: null,
        empo:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main5Base
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main5Base
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main5Base
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main5Base
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main5Base
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '订单号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单号 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '订单名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        empoid: [
            { type: 'string', message: '订单号(自动) 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单号(自动) 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单号(自动) 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单号(自动) 值不能为空', trigger: 'blur' },
        ],
        rempid: [
            { type: 'string', message: '采购员 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购员 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购员 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购员 值不能为空', trigger: 'blur' },
        ],
        rempname: [
            { type: 'string', message: '采购员 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购员 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购员 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购员 值不能为空', trigger: 'blur' },
        ],
        pdate: [
            { type: 'string', message: '订购日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订购日期 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '订购日期 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '订购日期 值不能为空', trigger: 'blur' },
        ],
        eadate: [
            { type: 'string', message: '预计到货日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '预计到货日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '预计到货日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '预计到货日期 值不能为空', trigger: 'blur' },
        ],
        labservicename: [
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'blur' },
        ],
        labservicedesc: [
            { type: 'string', message: '供应商备注 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '供应商备注 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '供应商备注 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '供应商备注 值不能为空', trigger: 'blur' },
        ],
        civo: [
            { type: 'string', message: '货物发票 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '货物发票 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '货物发票 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '货物发票 值不能为空', trigger: 'blur' },
        ],
        payway: [
            { type: 'string', message: '付款方式 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '付款方式 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '付款方式 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '付款方式 值不能为空', trigger: 'blur' },
        ],
        taxivo: [
            { type: 'string', message: '关税发票 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '关税发票 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '关税发票 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '关税发票 值不能为空', trigger: 'blur' },
        ],
        taxfee: [
            { type: 'string', message: '关税 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '关税 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '关税 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '关税 值不能为空', trigger: 'blur' },
        ],
        tsivo: [
            { type: 'string', message: '运杂费发票 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '运杂费发票 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '运杂费发票 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '运杂费发票 值不能为空', trigger: 'blur' },
        ],
        tsfee: [
            { type: 'string', message: '运杂费 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '运杂费 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '运杂费 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '运杂费 值不能为空', trigger: 'blur' },
        ],
        poamount: [
            { type: 'string', message: '物品金额 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品金额 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品金额 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品金额 值不能为空', trigger: 'blur' },
        ],
        postate: [
            { type: 'number', message: '订单状态 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '订单状态 值必须为数值类型', trigger: 'blur' },
            { required: true, type: 'number', message: '订单状态 值不能为空', trigger: 'change' },
            { required: true, type: 'number', message: '订单状态 值不能为空', trigger: 'blur' },
        ],
        wfstep: [
            { type: 'string', message: '流程步骤 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '流程步骤 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '流程步骤 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '流程步骤 值不能为空', trigger: 'blur' },
        ],
        apprempid: [
            { type: 'string', message: '批准人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '批准人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '批准人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '批准人 值不能为空', trigger: 'blur' },
        ],
        apprempname: [
            { type: 'string', message: '批准人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '批准人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '批准人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '批准人 值不能为空', trigger: 'blur' },
        ],
        apprdate: [
            { type: 'string', message: '批准日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '批准日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '批准日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '批准日期 值不能为空', trigger: 'blur' },
        ],
        orgid: [
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'blur' },
        ],
        description: [
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'blur' },
        ],
        content: [
            { type: 'string', message: '合同内容 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '合同内容 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '合同内容 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '合同内容 值不能为空', trigger: 'blur' },
        ],
        att: [
            { type: 'string', message: '附件 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '附件 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '附件 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '附件 值不能为空', trigger: 'blur' },
        ],
        labserviceid: [
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '产品供应商 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '产品供应商 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main5Base
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '订单信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: true, form: this, isControlledContent: false , uiActionGroup: { caption: '', langbase: 'entities.empo.main5_form', extractMode: 'ITEM', details: [] }, isManageContainer: false, showMoreModeItems: []  })
, 
        grouppanel1: new FormGroupPanelModel({ caption: '其它', detailType: 'GROUPPANEL', name: 'grouppanel1', visible: true, isShowCaption: true, form: this, isControlledContent: false , uiActionGroup: { caption: '', langbase: 'entities.empo.main5_form', extractMode: 'ITEM', details: [] }, isManageContainer: false, showMoreModeItems: []  })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this, isControlledContent: false  })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '订单号', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '订单名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        empoid: new FormItemModel({ caption: '订单号(自动)', detailType: 'FORMITEM', name: 'empoid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 0 })
, 
        rempid: new FormItemModel({ caption: '采购员', detailType: 'FORMITEM', name: 'rempid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        rempname: new FormItemModel({ caption: '采购员', detailType: 'FORMITEM', name: 'rempname', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        pdate: new FormItemModel({ caption: '订购日期', detailType: 'FORMITEM', name: 'pdate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        eadate: new FormItemModel({ caption: '预计到货日期', detailType: 'FORMITEM', name: 'eadate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        labservicename: new FormItemModel({ caption: '产品供应商', detailType: 'FORMITEM', name: 'labservicename', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        labservicedesc: new FormItemModel({ caption: '供应商备注', detailType: 'FORMITEM', name: 'labservicedesc', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        civo: new FormItemModel({ caption: '货物发票', detailType: 'FORMITEM', name: 'civo', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        payway: new FormItemModel({ caption: '付款方式', detailType: 'FORMITEM', name: 'payway', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        taxivo: new FormItemModel({ caption: '关税发票', detailType: 'FORMITEM', name: 'taxivo', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        taxfee: new FormItemModel({ caption: '关税', detailType: 'FORMITEM', name: 'taxfee', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        tsivo: new FormItemModel({ caption: '运杂费发票', detailType: 'FORMITEM', name: 'tsivo', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        tsfee: new FormItemModel({ caption: '运杂费', detailType: 'FORMITEM', name: 'tsfee', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        poamount: new FormItemModel({ caption: '物品金额', detailType: 'FORMITEM', name: 'poamount', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        postate: new FormItemModel({ caption: '订单状态', detailType: 'FORMITEM', name: 'postate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        wfstep: new FormItemModel({ caption: '流程步骤', detailType: 'FORMITEM', name: 'wfstep', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        apprempid: new FormItemModel({ caption: '批准人', detailType: 'FORMITEM', name: 'apprempid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        apprempname: new FormItemModel({ caption: '批准人', detailType: 'FORMITEM', name: 'apprempname', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        apprdate: new FormItemModel({ caption: '批准日期', detailType: 'FORMITEM', name: 'apprdate', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        orgid: new FormItemModel({ caption: '组织', detailType: 'FORMITEM', name: 'orgid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        description: new FormItemModel({ caption: '描述', detailType: 'FORMITEM', name: 'description', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        content: new FormItemModel({ caption: '合同内容', detailType: 'FORMITEM', name: 'content', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        att: new FormItemModel({ caption: '附件', detailType: 'FORMITEM', name: 'att', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
        labserviceid: new FormItemModel({ caption: '产品供应商', detailType: 'FORMITEM', name: 'labserviceid', visible: true, isShowCaption: true, form: this, isControlledContent: false , disabled: false, enableCond: 3 })
, 
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empoid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.empoid')
    onEmpoidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empoid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.rempid')
    onRempidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.rempname')
    onRempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 pdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.pdate')
    onPdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'pdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eadate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.eadate')
    onEadateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eadate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 labservicename 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.labservicename')
    onLabservicenameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'labservicename', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 labservicedesc 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.labservicedesc')
    onLabservicedescChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'labservicedesc', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 civo 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.civo')
    onCivoChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'civo', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 payway 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.payway')
    onPaywayChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'payway', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 taxivo 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.taxivo')
    onTaxivoChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'taxivo', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 taxfee 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.taxfee')
    onTaxfeeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'taxfee', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 tsivo 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.tsivo')
    onTsivoChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'tsivo', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 tsfee 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.tsfee')
    onTsfeeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'tsfee', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 poamount 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.poamount')
    onPoamountChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'poamount', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 postate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.postate')
    onPostateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'postate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wfstep 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.wfstep')
    onWfstepChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wfstep', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 apprempid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.apprempid')
    onApprempidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'apprempid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 apprempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.apprempname')
    onApprempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'apprempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 apprdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.apprdate')
    onApprdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'apprdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 orgid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.orgid')
    onOrgidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'orgid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 description 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.description')
    onDescriptionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'description', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 content 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.content')
    onContentChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'content', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 att 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.att')
    onAttChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'att', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 labserviceid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main5Base
     */
    @Watch('data.labserviceid')
    onLabserviceidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'labserviceid', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 显示更多模式切换操作
     *
     * @type {string}
     * @memberof Main5Base
     */
    public manageContainerClick(name: string){
        let model = this.detailsModel[name];
        if(model.isManageContainer){
            model.setManageContainerStatus(!model.manageContainerStatus);
            model.showMoreModeItems.forEach((item:any) => {
                if(this.detailsModel[item].isControlledContent){
                    this.detailsModel[item].setVisible(model.manageContainerStatus? this.detailsModel[item].oldVisible : false);
                }
            });
        }
    }

    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main5Base
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
     * @memberof Main5Base
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main5Base
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                



































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main5Base
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main5Base
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.empo){
            Object.assign(this.context,{empo:data.empo})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main5Base
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main5Base
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main5Base
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main5Base
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main5Base
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main5Base
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main5Base
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main5Base
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main5Base
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main5Base
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main5Base
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main5Base
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    if(this.context.srfsourcekey){
                        this.copy(this.context.srfsourcekey);
                    }else{
                        this.loadDraft(data);
                    }
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main5Base
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main5Base
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main5Base
     */
    public copy(srfkey: string): void {
        let copyData = this.$store.getters.getCopyData(srfkey);
        copyData.srfkey = Util.createUUID();
        copyData.empo = copyData.srfkey;
        copyData.empoid = copyData.srfkey;
        Object.assign(this.context,{empo:copyData.empo})
        this.data = copyData;
        this.$nextTick(() => {
          this.formState.next({ type: 'load', data: copyData });
          this.data.srfuf = '0';
          this.setFormEnableCond(this.data);
        });
    }

    /**
     *打印
     *@memberof @memberof Main5Base
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'empo_main5',popTitle:'订单<主编辑>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main5Base
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main5Base
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main5Base
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMPOEditView9_EditMode视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main5Base
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMPOEditView9_EditMode视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.empo){
                Object.assign(this.context,{empo:data.empo})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main5Base
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMPOEditView9_EditMode视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            AppCenterService.notifyMessage({name:"EMPO",action:'appRefresh',data:data});
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                if(response.data.errorKey && Object.is(response.data.errorKey,"versionCheck")){
                    this.$Modal.confirm({
                        title: '保存数据发生错误',
                        content: '数据不一致，可能后台数据已经被修改,是否要重新加载数据？',
                        onOk: () => {
                            this.refresh([]);
                        },
                        onCancel: () => { }
                    });
                }else{
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main5Base
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMPOEditView9_EditMode视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                AppCenterService.notifyMessage({name:"EMPO",action:'appRefresh',data:data});
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    if(response.data.errorKey && Object.is(response.data.errorKey,"versionCheck")){
                        this.$Modal.confirm({
                            title: '保存数据发生错误',
                            content: '数据不一致，可能后台数据已经被修改,是否要重新加载数据？',
                            onOk: () => {
                                this.refresh([]);
                            },
                            onCancel: () => { }
                        });
                    }else{
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                    }
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof Main5Base
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMPOEditView9_EditMode视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    AppCenterService.notifyMessage({name:"EMPO",action:'appRefresh',data:data});
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main5Base
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main5Base
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.empo || Object.is(arg.empo, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                AppCenterService.notifyMessage({name:"EMPO",action:'appRefresh',data:data});
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                // 强制补充srfwfmemo
                if(this.srfwfmemo){
                    Object.assign(arg,{srfwfmemo:this.srfwfmemo});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main5Base
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            AppCenterService.notifyMessage({name:"EMPO",action:'appRefresh',data:data});
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main5Base
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main5Base
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main5Base
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main5Base
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main5Base
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter === 0){
            this.save(this.drsaveopt, undefined, false).then((res) =>{
                this.saveState(res);
                this.drsaveopt = {};
                if(Object.is(_this.currentAction, "saveAndNew")){
                    _this.ResetData(res);
                    _this.loadDraft({});
                }else if(Object.is(_this.currentAction, "saveAndExit")){
                    if(res){
                        _this.closeView(res.data);
                    }
                }
            });
        }
    }

    /**
     * 新建默认值
     * @memberof Main5Base
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main5Base
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main5-form.less';
</style>